/////// Nokia 5110 LCD sceen///////
#include <PCD8544.h>
PCD8544 lcd;

///////sensor HC-SR04///////
//variable for HC-SR04

const int trigPin = 9;
const int echoPin = 10;
long duration;
int distance;
int startDistance = 30; // value of the distance (in cm) to start the timer

///////Buzzer///////
//variable for buzzer
const int buzzer = 8;
const int songLength = 18;
char notes[] = "cdfda ag cdfdg gf "; // a space represents a rest
int beats[] = {1, 1, 1, 1, 1, 1, 4, 4, 2, 1, 1, 1, 1, 1, 1, 4, 4, 2};
int tempo = 113;

void setup() {
  Serial.begin(9600); //Initialisation of serial port 
  lcd.begin(84, 48); 
  pinMode(buzzer, OUTPUT);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  FirstMessage(); //function to print first message
}


int delayTimer = 30; // delay of the timer in seconds
///////////////intermediate function//////////////////////////////////

///////////////////////////////////////////////////////
void FirstMessage() { //function ro print first message

  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("   Hello  ");
  lcd.setCursor(0, 1);
  lcd.print("Please start  the timer");
}

///////////////////////////////////////////////////////
void calculateDistance() {//function to calculate distance for start timer
  Serial.println("calculateDistance");
  // Clears the trigPin
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  distance = duration * 0.034 / 2;
  Serial.println(distance);
}

///////////////////////////////////////////////////////
void startMusicBuzzer () {//function to play timer start music

  for (int i = 0; i < 3; i ++) {
    tone(buzzer, 1000);
    delay(400);
    noTone(buzzer);
    delay(100);
  }
  tone(buzzer, 2000);
  delay(1000);
  noTone(buzzer);
  delay(1000);
}

///////////////////////////////////////////////////////
void onScreenTimer () {//function to print on the sceen the remaining time
  for (delayTimer; delayTimer >= 0; delayTimer = delayTimer - 1) {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Remaining ");
    lcd.setCursor(0, 1);
    lcd.print("time :"); 
    lcd.setCursor(4, 3);
    lcd.print(delayTimer);
    lcd.print(" seconds");
    delay(1000);
  }
}

///////////////////////////////////////////////////////
void endMusic() {//function to play timer end music
  lcd.clear();
  lcd.setCursor(4, 3);
  lcd.print("well done !");
  int i, duration;
  for (i = 0; i < songLength; i++) // step through the song arrays
  {
    duration = beats[i] * tempo;  // length of note/rest in ms
    if (notes[i] == ' ')          // is this a rest?
    {
      delay(duration);            // then pause for a moment
    }
    else                          // otherwise, play the note
    {
      tone(buzzer, frequency(notes[i]), duration);
      delay(duration);            // wait for tone to endMusicish
    }
    delay(tempo / 10);            // brief pause between notes
  }
  
}


int frequency(char note) {

  int i;
  const int numNotes = 8;  // number of notes we're storing

  char names[] = { 'c', 'd', 'e', 'f', 'g', 'a', 'b', 'C' };
  int frequencies[] = {262, 294, 330, 349, 392, 440, 494, 523};
  for (i = 0; i < numNotes; i++)  // Step through the notes
  {
    if (names[i] == note)         // Is this the one?
    {
      return (frequencies[i]);    // Yes! Return the frequency
    }
  }
  return (0); // We looked through everything and didn't endMusicd it,

}

void loop() {
  calculateDistance();

  if (distance <= startDistance) { //if the distance is greater than startDistance
    startMusicBuzzer();//play start music
    onScreenTimer();   //print on the sceen the remaining time
    endMusic();        //play end music
    FirstMessage();// print first message
  }
}
